PROGRAM cdpsidd;

USES
 Windows,
  CDPSIDClass in 'CDPSIDClass.pas';

FUNCTION IntToStr( Value : Int64 ) : STRING;
 VAR i : Integer;
 BEGIN
  Result:='';
  WHILE (Value>0) DO
   BEGIN
    i:=Value MOD 10;
    Result:=Chr(Ord('0')+i)+Result;
    Value:=Value DIV 10;
   END;
 END; {* FUNC IntToStr *}

TYPE TCDPSIDMethod = ( mUnknown, mCipher, mDeCipher );

VAR CDPSID : TCDPSIDClass;
    Q1, Q2, F : Int64;
    FileNameKeyIn : STRING = '';
    FileNameIn : STRING = '';
    FileNameOut : STRING = '';
    i : Integer;
    s : STRING;
    c : PChar;
    Method : TCDPSIDMethod = mUnknown;
    Generate : Boolean = False;
    Error : Boolean;

BEGIN
 WriteLn('CDPSID Delphi Version 0.9 suivant CDPSID 0.9');
 WriteLn('Par dino99 <dino99@wanadoo.fr>');
 WriteLn('');
 Error:=False;
 FOR i:=1 TO ParamCount DO
  BEGIN
   s:=ParamStr(i);
   c:=PChar(s);
   IF (c^='/') OR (c^='-') THEN
    BEGIN
     Inc(c);
     WHILE (c^ IN ['a'..'z']) DO
      BEGIN
       CASE c^ OF
        'c', 'C' : IF (Method=mUnknown) THEN
                    Method:=mCipher
                   ELSE
                    Error:=True;
        'd', 'D' : IF (Method=mUnknown) THEN
                    Method:=mDecipher
                   ELSE
                    Error:=True;
        'g', 'G' : Generate:=True;
       END;
       Inc(c);
      END;
    END
   ELSE
    IF (FileNameKeyIn='') THEN
     FileNameKeyIn:=s
    ELSE
     IF (FileNameIn='') THEN
      FileNameIn:=s
     ELSE
      IF (FileNameOut='') THEN
       FileNameOut:=s
      ELSE
       Error:=True;
  END;

 IF NOT Error AND (FileNameKeyIn<>'') AND (FileNameIn<>'') AND (FileNameOut<>'') THEN
  BEGIN
   Randomize;
   QueryPerformanceFrequency(F);
   CDPSID:=TCDPSIDClass.Create;
   TRY
    IF Generate THEN
     BEGIN
      CDPSID.Randomize;
      CDPSID.Validate;
      CDPSID.SaveToFile(FileNameKeyIn);
     END
    ELSE
     CDPSID.LoadFromFile(FileNameKeyIn);
    QueryPerformanceCounter(Q1);
    CASE Method OF
     mCipher : CDPSID.CipherToFile(FileNameIn, FileNameOut);
     mDeCipher : CDPSID.DeCipherToFile(FileNameIn, FileNameOut);
    END;
    QueryPerformanceCounter(Q2);
    CASE Method OF
     mCipher   : WriteLn('Cryptage du fichier '''+FileNameIn+''' realise en '+IntToStr((Q2-Q1) DIV F)+' s');
     mDeCipher : WriteLn('Decryptage du fichier '''+FileNameIn+''' realise en '+IntToStr((Q2-Q1) DIV F)+' s');
    END;
   FINALLY
    CDPSID.Free;
   END;
  END
 ELSE
  BEGIN
   WriteLn('Syntax: CDPSID <keyfile> <filein> <fileout> ( /c | /d ) [ /g ]');
   WriteLn('');
   WriteLn('  <keyfile> : Fichier contenant la grille de codage');
   WriteLn('  <filein>  : Fichier a crypter/decrypter');
   WriteLn('  <fileout> : Fichier de sortie du apres cryptage/decryptage');
   WriteLn('');
   WriteLn('  /c        : Crypter');
   WriteLn('  /d        : Decrypter');
   WriteLn('  /g        : Generer une grille de codage et l''enregistrer dans <keyfile>');
  END;
 ReadLn;
END.
